package com.keypalette.theme

//import com.pretty.keyboard.theme.keyboard.helper.ObjectBox
import android.app.Application
import android.graphics.Typeface
import com.keypalette.theme.dataabout.resource.Data
import com.keypalette.theme.dataabout.resource.WrapperData
import org.json.JSONArray
import java.io.BufferedReader
import java.io.IOException
import java.io.InputStream
import java.io.InputStreamReader
import java.io.StringWriter


class KeyApp : Application() {
    companion object {
        lateinit var keyAppInstance: KeyApp

        lateinit var list: List<WrapperData>

        const val TAG = "-----------------"
        var defaultFont: Typeface? = null
        const val DB_VERSION = 1
        const val DB_NAME = "db_name"
    }

    override fun onCreate() {
        super.onCreate()
        keyAppInstance = this
        defaultFont = Typeface.createFromAsset(assets, "font5.ttf")
        dealFile()


    }

    private fun dealFile() {
        val openFile = keyAppInstance.assets.open("data.json")
        val jsonString = getJsonString(openFile)
        if (jsonString != null) {
            resolveJsonString(jsonString)
        }
    }


    private fun resolveJsonString(string: String) {
        val jsonData = JSONArray(string)
        var dataList: MutableList<WrapperData> = mutableListOf()
        for (i in 0 until jsonData.length()) {
            jsonData.getJSONObject(i).run {
                val pName = getString("parent_name")
                val listArray = getJSONArray("keyboard_list")
                var mList: MutableList<Data> = mutableListOf()
                for (listIndex in 0 until listArray.length()) {
                    listArray.getJSONObject(listIndex).also {
                        val title = it.getString("title")
                        val thUrl = it.getString("thumbUrl")
                        val thGif = it.getString("thumbUrlGif")
                        var zipPath = ""
                        var imgPath = ""
                        var imgGif = ""
                        var imgPreviewGif = ""
                        if (it.has("detail")) {
                            val contentObject =
                                it.getJSONObject("detail").getJSONObject("themeContent")
                            zipPath = contentObject.getString("androidRawZipUrl")
                            imgPath = contentObject.getString("img")
                            imgGif = contentObject.getString("imgGif")
                            imgPreviewGif = contentObject.getString("imgPreviewGif")
                        } else {

                        }
                        mList.add(
                            Data()
                                .apply {
                            setImgPath(imgPath)
                            setZipPath(zipPath)
                            setTitleName(title)
                            setImgGif(imgGif)
                            thumbUrl = thUrl
                            thumbGif = thGif
                        })

                    }

                }
                val shuffled = mList.shuffled()
                val dataWrapperData = WrapperData()
                    .apply {
                    parentName = pName
                    keyboardList = shuffled
                }
                dataList.add(dataWrapperData)

            }
        }

        updateDataList(dataList)

    }

    private fun updateDataList(mainList: MutableList<WrapperData>) {

        list = mainList.shuffled()

    }
    private fun getJsonString(fileInputStream: InputStream): String? {
        return try {
            val charArray = CharArray(fileInputStream.available())
            var readCount = 0
            val streamReader = InputStreamReader(fileInputStream)
            val bufferedReader = BufferedReader(streamReader)
            val stringWriter = StringWriter()
            while (bufferedReader.read(charArray).also { readCount = it } != -1) {
                stringWriter.write(charArray, 0, readCount)
            }
            stringWriter.toString()
        } catch (e: IOException) {
            ""
        }
    }





}